.TH Animate 1.4 "January 1998"
.UC
.SH NAME
Animate \- the AfterStep Animate module
.SH SYNOPSIS
Animate is spawned by afterstep, so no command line invocation will work.
From within the autoexec file or as a menu option, Animate is spawned as
follows:
.nf
.sp
Module Animate
.sp
.fi
or from within an afterstep pop-up menu by 'Animate' without 'Module':
.nf
.sp
% cat "~/GNUstep/Library/AfterStep/start/Modules/Animate iconify"
Animate
.fi

.SH DESCRIPTION
The Animate module animates window actions.  It currently animates
iconification and deiconification in a zoom style or a twisty spinning style.

.SH INITIALIZATION
During initialization, \fIAnimate\fP will eventually search a 
configuration file which describes the time-outs and actions to take.
The configuration file is ~/GNUstep/Library/AfterStep/animate .

.SH INVOCATION
The invocation method was shown in the synopsis section

.SH CONFIGURATION OPTIONS
Animate reads ~/GNUstep/Library/AfterStep/animate when it starts up,
and looks for certain configuration options:

.IP "*AnimateColor \fBcolor\fP"
Tells Animate what color to draw with.

.IP "*AnimateDelay \fBmsecs\fP"
Tells Animate how many milliseconds to sleep between frames of animation.

.IP "*AnimateIterations \fBiterations\fP"
Tells Animate how many steps to break the animation into.

.IP "*AnimateTwist \fBtwist\fP"
Tells Animate how many revolutions to twist the iconification frame.

.IP "*AnimateWidth \fBwidth\fP"
Tells Animate how wide a line to draw with.  Note that with 0 is a fast line
at Width 1

.IP "*AnimateResize \fBmode\fP"
Tells Animate what method to use to draw resizes.  \fIzoom\fP, \fItwist\fP,
\fIflip\fP, \fIturn\fP & \fIrandom\fP are currently supported.

.SH AUTHORS
Alfredo Kengi Kojima <kojima@inf.ufrgs.br>

Kaj Groner <kajg@mindspring.com>

Frank Scheelen <scheelen@worldonline.nl>
