.\" t
.\" @(#)Ident.1	1/12/94
.TH Ident 1.20 "Jan 28 1994"
.UC
.SH NAME
Ident \- the AfterStep identify-window module
.SH SYNOPSIS
Ident is spawned by AfterStep, so no command line invocation will work.

.SH DESCRIPTION
The Ident module prompts the user to select a target window, if
the module was not launched from within a window context in AfterStep.
After that, it pops up a window with information about the window
which was selected.

Ident reads ~/GNUstep/Library/AfterStep/ident file when it starts up,
and looks for lines similar to "*IdentFore green".

.SH INITIALIZATION
During initialization, \fIIdent\fP will eventually search a 
configuration file which describes the colors and font to use.

If the Ident executable is linked to another name, ie 'ln -s
Ident MoreIdentify', then another module called MoreIdentify can be
started, with a completely different configuration than Ident,
simply by changing the keyword  Ident to MoreIdentify. This way multiple
Identify programs can be used.

.SH INVOCATION
Ident can be invoked by binding the action 'Module Ident' to a menu or
key-stroke in the feel file.
AfterStep will search directory specified in the ModulePath configuration
option to attempt to locate Ident. Although nothing keeps you from
launching Ident at start-up time, you probably don't want to.

.SH CONFIGURATION OPTIONS
Ident reads ~/GNUstep/Library/AfterStep/ident file when it starts up, and looks
for lines as listed below:

.IP "*IdentFore \fIcolor\fP"
Tells the module to use \fIcolor\fP instead of black for text.

.IP "*IdentBack \fIcolor\fP"
Tells the module to use \fIcolor\fP instead of black for the window
background.

.IP "*IdentFont \fIfontname\fP"
Tells the module to use \fIfontname\fP instead of fixed for text.

.SH AUTHOR
Robert Nation

Nobutaka Suzuki <nobuta-s@is.aist-nara.ac.jp>

