.\" t
.\" @(#)Pager.1	6/4/98
.TH Pager 1.30 "Jun 4 1998"
.UC
.SH NAME
Pager \- the Afterstep Pager module
.SH SYNOPSIS
Pager is spawned by afterstep, so no command line invocation will work.
From within the autoexec file or as a menu option, Pager is spawned as follows:
.nf
.sp
Module Pager 0 3
.sp
.fi
or from within an afterstep pop-up menu:
.nf
.sp
% cat "~/GNUstep/Library/AfterStep/start/Modules/Virtual desktop"
Pager 0 3
.sp
.fi
where "0" is the first desktop to show, and "3" is the last.

.SH DESCRIPTION
The Pager module shows a miniature view of the Afterstep desktops which
are specified in the command line. This is a useful reminder of where
your active windows are. Windows in the pager are shown in the same
color as their afterstep decorations. 

The pager can be used to change your viewport into the current
desktop, to change desktops, or to move windows around.

Pressing mouse button 1 in the pager will cause you viewport to
change to the selected page of the selected desk. If you click with
button 1 in the desk-label area, you will switch desks but not
pages within the desk.

Dragging mouse button 2 on a miniature view of a window will cause
that window to be move to the location where you release the mouse
button, but your viewport will not change. If you drag the window
out of the pager and onto your desktop, a full size image of
the window will appear for you to place. There is no way to
pick up a full size image of the window and move it into the pager,
however. Since some mice do not have button 2, I have made provisions to drag 
windows in the pager by using pressing modifier-1 (usually Alt) and dragging 
with button 3.

Clicking mouse button 3 on a location within the current desktop will
cause the viewport to move to the selected location, but will not
align the viewport to a page boundary. Dragging button 3 will
cause the viewport to move as you drag. Button 3 operations are
limited to the current desktop only.

When iconified, the pager will work as a fully functional current page
only pager. Windows and viewports can be moved within the icon of the
pager. Users will want to make sure that they have no lines similar to
.nf
.sp
Icon "Pager" whatever
.sp
.fi
in their feel files.

.SH INITIALIZATION
During initialization, \fIPager\fP will eventually search a 
configuration file which describes the time-outs and actions to take.
The configuration file is ~/GNUstep/Library/AfterStep/pager .

If the Pager executable is linked to another name, ie ln -s
Pager OtherPager, then another module called OtherPager can be
started, with a completely different configuration than Pager,
simply by changing the keyword  Pager to OtherPager. This way multiple
Pager programs can be used.

.SH KEYBOARD FOCUS CONTROL
You can direct the keyboard focus to any window on the current desktop
by clicking with button 2 on its image in the pager. The window does
not need to be visible, but it does need to be on the current page.

.SH INVOCATION
The invocation method was shown in the synopsis section

.SH CONFIGURATION OPTIONS
Pager reads ~/GNUstep/Library/AfterStep/pager file when it starts up,
and looks for certain configuration options:

.IP "*PagerGeometry \fIgeometry\fP"
Completely or partially specifies the pager windows location and
geometry, in standard X11 notation. 
In order to maintain an undistorted aspect ratio, you might
want to leave out either the width or height dimension of the
geometry specification

.IP "*PagerRows \fIrows\fP"
Tells afterstep how many rows of desks to use when laying out the pager
window.

.IP "*PagerColumns \fIcolumns\fP"
Tells afterstep how many columnss of desks to use when laying out the pager
window.

.IP "*PagerIconGeometry \fIgeometry\fP"
Specifies a size (optional) and location (optional) for the pager's icon 
window. Since there is no easy way for Pager to determine the height of the
icon's label, you will have to make an allowance for the icon  label height
when using negative y-coordinates in the icon location specification (used to
specify a location relative to the bottom instead of the top of the screen).

.IP "*PagerStartIconic"
Causes the pager to start iconified. 

.IP "*PagerFont \fIfont-name\fP"
Specified a font to use to label the desktops. If \fIfont_name\fP is
"none" then no desktop labels will be displayed.

.IP "*PagerSmallFont \fIfont-name\fP"
Specified a font to use to label the window names in the pager. If not
specified, the window labels will be omitted. Window labels seem to
be fairly useless for desktop scales of 32 or greater.

.IP "*PagerFore \fIcolor\fP"
Specifies the color to use to write the desktop labels, and
to draw the page-grid lines.

.IP "*PagerBack \fIcolor\fP"
Specifies the background color for the window.

.IP "*PagerHilight \fIcolor\fP"
The active page and desk label will be highlighted by using this
background pattern instead of the normal background.

.IP "*PagerLabel \fIdesk label\fP"
Assigns the text \fIlabel\fP to desk \fIdesk\fP in the pager window.
Useful for assigning symbolic names to desktops, ie
.nf
.sp
*PagerLabel  0  Work
*PagerLabel  1  WWW
*PagerLabel  2  Mail
*PagerLabel  3  Games
.sp
.fi

.IP "*PagerDesktopImage \fIdesk image\fP"
Sets \fIimage\fP as the root window background for desktop \fIdesk\fP. 
The image will be also scaled down and used as background for the Desktop
representation in the Pager window. If image is not XPM or JPEG format,
external image loader application will be used to display it on Root.
That application is specified at compilation time.
.nf
.sp
*PagerDesktopImage 0 ~/GNUstep/Library/AfterStep/non-configurable/0_background
*PagerDesktopImage 1 ~/GNUstep/Library/AfterStep/non-configurable/1_background
*PagerDesktopImage 2 ~/GNUstep/Library/AfterStep/non-configurable/2_background
*PagerDesktopImage 3 ~/GNUstep/Library/AfterStep/non-configurable/3_background
.sp
.fi

.IP "*PagerXImageLoaderArgs \fI[desk] arg1 arg2 ... argN\fP"
This option will let you overide external image loader args 
specified at compilation time for desk \fIdesk\fP, or all desks if ommited.

Warning:
When \fIdesk\fP is used to specify desk - it will also disable internal XPM
and JPEG support for this desk!

.nf
.sp
*PagerXImageLoaderArgs 0 -onroot -quiet
*PagerXImageLoaderArgs 1 -onroot -quiet
*PagerXImageLoaderArgs 2 -onroot -quiet
*PagerXImageLoaderArgs 3 -onroot -quiet
.sp
.fi

.IP "*PagerImage \fIdesk image\fP"
Sets \fIimage\fP as the as background for the Desktop \fIdesk\fP
representation in the Pager window. Use it if you want to specify 
different image for Pager window then scaled down Root background.
.nf
.sp
*PagerImage 0 ~/GNUstep/Library/AfterStep/non-configurable/0_background
*PagerImage 1 ~/GNUstep/Library/AfterStep/non-configurable/1_background
*PagerImage 2 ~/GNUstep/Library/AfterStep/non-configurable/2_background
*PagerImage 3 ~/GNUstep/Library/AfterStep/non-configurable/3_background
.sp
.fi
Defalts will set it to the same image, as used for the Root background.

.IP "*PagerFastBackground \fIdesk yes/no [tile_hsize [tile_vsize]]\fP"
This option has only effect, when you are using non-XPM and non-JPEG files
as the root background. When set to 'yes' it will store image, displayed by
external viewer application, in memory, using it later on when you switch
between desks. 
That can grately increase speed, but will also result in more memory used
(apprx. 1Mb per desktop ), therefor it is not recommended on systems with 
small amount of RAM. If you are using small image tiled on your root, you
will want to specify image
sizes in \fItile_hsize\fP and \fItile_vsize\fP to reduce memory used. 
If you ommit any of these, the screen dimention will be used.
Also, to reduce memory used, you can set this to 'yes' only for most used desk's.
By default FastBackground is set to No and tile size set to the screen dimentions.
.fi

.IP "*PagerRedrawBg \fInumber\fP"
If 0, will not update background change, use this with xearth or xfishtank.
Default is 1, i.e. update background.


.IP "*PagerAlign \fILabelPosition\fP"
Sets the alignment of the labels for the desktops. Use 0 for centered,
>0 for left, <0 for right alignment. If <>0 the absolute value of
\fILabelPosition\fP will be the distance between label text and
window border.


.IP "*DeskTopScale \fInumber\fP"
If the geometry is not specified, then a desktop reduction factor is
used to calculate the pager's size. Things in the pager window
are shown at 1/\fInumber\fP of the actual size.


.IP "*Balloons"
Show a balloon describing the window when the pointer is moved into
a window in the pager. Currently only the window's icon name is shown.
Note that balloons are not shown for the iconified pager.


.IP "*BalloonFore \fIcolor\fP"
Specifies the color for text in the balloon window. If omitted it
defaults to the foreground color for the window being described.


.IP "BalloonBack \fIcolor\fP"
Specifies the background color for the balloon window. If omitted it
defaults to the background color for the window being described.


.IP "BalloonFont \fIfont-name\fP"
Specifies a font to use for the balloon text. Defaults to \fIfixed\fP.


.IP "BalloonBorderWidth \fInumber\fP"
Sets the width of the balloon window's border. Defaults to 1.


.IP "BalloonBorderColor \fIcolor\fP"
Sets the color of the balloon window's border. Defaults to black.


.IP "BalloonYOffset \fInumber\fP"
The balloon window is positioned to be horizontally centered against
the pager window it is describing. The vertical position may be
set as an offset. Negative offsets of \fI-n\fP are placed \fIn\fP
pixels above the pager window, positive offsets of \fI+n\fP are placed
\fIn\fP pixels below. Offsets of 0 are not permitted, as this would permit
direct transit from pager window to balloon window, causing an event
loop. Defaults to +2.

.IP "MaxBackgroundColors \fInumber\fP"
Will let you limit number of colors, used to display any individual background.
It might not yeild expected result, as far as this feature implemented in image
format library used, and not always in right way.

.nf
.sp
MaxBackgroundColors   50
.sp
.fi

.SH AUTHORS
Robert Nation

Alfredo Kojima

Guylhem Aznar

Ric Lister

Sasha Vasko
